# ARST打卡第255周

<!--more-->

lc2549_统计桌面上的不同数字 【TED演讲】勇气与恐惧之间 grpc C++ Basics tutorial 继承grpc接口发送http请求

## Algorithm
lc2549_统计桌面上的不同数字

思路:
因为 n 在 `[1, 100]` , 而天数有10亿天，每天都是桌上所有数字减一之后的所有子因数。
所以永远返回 n-1 即可。

当然要特殊判断 n = 1 的时候还是返回 1.

```cpp
class Solution {
public:
    int distinctIntegers(int n) {
        return n == 1 ? 1 : n - 1;
    }
};
```

题解数学法一模一样，模拟法就是模拟题目过程，感兴趣的去看。

## Review
【TED演讲】勇气与恐惧之间

<div align = "center">
    <iframe  width="100%" height="700" src="//player.bilibili.com/player.html?aid=1151931027&bvid=BV1iZ421b79n&cid=1472209820&p=1" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>
</div>

人生所有的重大选择都伴随着恐惧和勇气，让我们为了想要的生活，克服恐惧，带着勇气前进。

## Tips
[grpc C++ Basics tutorial](https://grpc.io/docs/languages/cpp/basics/)

## Share
继承grpc接口发送http请求

**如果需要发送http的客户端，而且又需要借用grpc自动生成rpc框架函数。**

可以实现一个继承 `grpc.ClientConnInterface` 的管道接口，并且重载其中的 Invoke 函数。 

```go
type KRpcChannel struct {
    grpc.ClientConnInterface
    // other data struct ...
}

func (channel *KRpcChannel) Invoke(ctx context.Context, methodDescriptor string, args any, reply any, opts ...grpc.CallOption) error {
    // ...
}
```

最后再把重载的管道填入grpc生成的服务框架，就可以用上自动生成的数据结构了。

```go
tsChannel := NewKRpcChannel(EndPoint, otherData)
tableService := NewTableServiceClient(tsChannel)
```
